'Oct 19

'Practice parsing files and with arrays of 
'dynamic controls

Imports System.IO


Public Class FrmQuoteQuiz
    'quote and author arrays to be read from file
    Dim Quote As String()
    Dim Author As String()

    'arrays of dynamic controls 
    'labels to display quotes 
    'comboboxes for user to guess author
    Dim lblQuote As Label()
    Dim cboAuthor As ComboBox()


    '***********************************************
    'read file the instantiate and initialize arrays
    'make corresponding arrays of dynamic controls
    Private Sub FrmQuoteQuiz_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim MyStreamReader As StreamReader
        Dim MyFile As String
        Dim Line As String()
        Dim MyToken As String()
        Dim i As Integer

        '******************************************
        'presentation size variables 
        'need to play with to get form to look good
        Dim LabelWidth As Integer = 640
        Dim LabelHeight As Integer = 30
        Dim LabelStartHeight As Integer = 280


        'read file 
        Try
            MyStreamReader = New StreamReader(Directory.GetCurrentDirectory & "\Quotes.txt")
            MyFile = MyStreamReader.ReadToEnd
            MyStreamReader.Close()
        Catch ex As Exception
            MsgBox("Problem readeing file.")
            Exit Sub
        End Try

        'parse file contents on return character
        Line = MyFile.Split(vbCrLf)

        'instantiate arrays
        Quote = New String(Line.Length - 1) {}
        Author = New String(Line.Length - 1) {}
        lblQuote = New Label(Line.Length - 1) {}
        cboAuthor = New ComboBox(Line.Length - 1) {}


        For i = 0 To Line.Length - 1
            'parse line initialize quote and author arrays
            Line(i) = Line(i).Trim
            MyToken = Line(i).Split("/")
            Quote(i) = MyToken(0)
            Author(i) = MyToken(1)

            'instantiate label for quote, 
            'add to form, size and 
            'position it, place quote in it
            lblQuote(i) = New Label
            Me.Controls.Add(lblQuote(i))
            lblQuote(i).Width = LabelWidth
            lblQuote(i).Height = LabelHeight
            lblQuote(i).AutoSize = False
            lblQuote(i).Location = New Point(50, LabelStartHeight + i * LabelHeight)
            lblQuote(i).Text = Quote(i)

            'instantiate label for quote, 
            'add to form, size and 
            'position it, place possible 
            'authors it it
            cboAuthor(i) = New ComboBox
            Me.Controls.Add(cboAuthor(i))
            'cboAuthor(i).Width = 100
            'cboAuthor(i).Height = LabelHeight
            cboAuthor(i).Location = New Point(lblQuote(i).Location.X + lblQuote(i).Width, LabelStartHeight + i * LabelHeight)
            cboAuthor(i).Items.Add("Franklin")
            cboAuthor(i).Items.Add("Twain")
            cboAuthor(i).Items.Add("Wilde")
        Next

    End Sub

    Private Sub btnGrade_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrade.Click
        Dim i As Integer
        Dim sum As Integer

        'check user's answers against correct answers 
        For i = 0 To Author.Length - 1
            If Author(i).ToLower = cboAuthor(i).Text.ToLower Then
                sum += 1
            End If
        Next

        MsgBox("You got " & sum & " out of " & Author.Length & ".")
    End Sub
End Class
